apiVersion: v1
kind: ConfigMap
metadata:
  name: {{ prometheus_name }}
  namespace: {{ namespace }}
data:
  prometheus.yml: |
    global:
      scrape_interval: {{ prometheus_scrape_interval }}
      evaluation_interval: {{ prometheus_eval_interval }}
      external_labels:
        monitor: opsperator-monitor

    rule_files:
    - /etc/prometheus/rules.d/*.yaml

    scrape_configs:
{% for member in prometheus_federation if member['name'] is defined and member['url'] is defined %}
    - job_name: fed{{ member['name'] }}
{% if member['authuser'] | default(False) or member['authtoken'] | default(False) %}
      basic_auth:
{% if member['authpass'] | default(False) and member['authtoken'] is not defined %}
        password: '{{ member['authpass'] }}'
{% endif %}
        username: {{ member['authtoken'] | default(member['authuser']) }}
{% endif %}
      honor_labels: true
      metrics_path: {{ member_federate_path | default('/federate') }}
      params:
        'match[]':
{% for job in member['matchjobs'] | default(['prometheus', 'kubelet', 'nodes', 'kubeci', 's3buckets', 'cluster', 'cadvisor']) %}
        - '{job="{{ job }}"}'
{% endfor %}
      scheme: {{ member['url'] | urlsplit('scheme') }}
      scrape_interval: {{ member['interval'] | default(prometheus_scrape_interval) }}
      scrape_timeout: {{ member['timeout'] | default(prometheus_scrape_timeout) }}
      static_configs:
      - targets:
        - {{ member['url'] | urlsplit('hostname') }}:{{ member['url'] | urlsplit('port') }}
{% if member['url'] | urlsplit('scheme') == 'https' %}
      tls_config:
        insecure_skip_verify: true
{% endif %}

{% endfor %}
    - job_name: prometheus
      static_configs:
      - labels:
          kubernetes_cluster: {{ prometheus_local_cluster }}
          kubernetes_namespace: {{ namespace }}
          kubernetes_service_name: {{ prometheus_name }}
          kubernetes_pod_name: {{ prometheus_name }}
        targets: ['127.0.0.1:9090']

    - job_name: cluster
      kubernetes_sd_configs:
      - role: endpoints
        selectors:
        - role: endpoints
          label: {{ prometheus_cluster_label }}={{ prometheus_match }}
      relabel_configs:
      - action: replace
        replacement: {{ prometheus_local_cluster }}
        source_labels: [__meta_kubernetes_endpoint_address_target_kind]
        target_label: kubernetes_cluster
      - action: replace
        source_labels: [__meta_kubernetes_namespace]
        target_label: kubernetes_namespace
      scheme: http
      scrape_interval: {{ prometheus_scrape_interval }}
      scrape_timeout: {{ prometheus_scrape_timeout }}

    - job_name: cadvisor
      bearer_token_file: /var/run/secrets/kubernetes.io/serviceaccount/token
      kubernetes_sd_configs:
      - role: node
      metrics_path: /metrics/cadvisor
      relabel_configs:
      - action: replace
        replacement: {{ prometheus_local_cluster }}
        source_labels: [__meta_kubernetes_endpoint_address_target_kind]
        target_label: kubernetes_cluster
      - action: replace
        source_labels: [__meta_kubernetes_node_name]
        target_label: kubernetes_node_name
      scheme: https
      scrape_interval: {{ prometheus_scrape_interval }}
      scrape_timeout: {{ prometheus_scrape_timeout }}
      tls_config:
        ca_file: /var/run/secrets/kubernetes.io/serviceaccount/ca.crt
        insecure_skip_verify: true

    - job_name: kubelet
      bearer_token_file: /var/run/secrets/kubernetes.io/serviceaccount/token
      kubernetes_sd_configs:
      - role: node
      relabel_configs:
      - action: replace
        replacement: {{ prometheus_local_cluster }}
        source_labels: [__meta_kubernetes_endpoint_address_target_kind]
        target_label: kubernetes_cluster
      - action: replace
        source_labels: [__meta_kubernetes_node_name]
        target_label: kubernetes_node_name
      scheme: https
      scrape_interval: {{ prometheus_scrape_interval }}
      scrape_timeout: {{ prometheus_scrape_timeout }}
      tls_config:
        ca_file: /var/run/secrets/kubernetes.io/serviceaccount/ca.crt
        insecure_skip_verify: true

    - job_name: nodes
      kubernetes_sd_configs:
      - role: endpoints
        selectors:
        - label: {{ prometheus_node_label }}={{ prometheus_match }}
          role: endpoints
      relabel_configs:
      - action: replace
        replacement: {{ prometheus_local_cluster }}
        source_labels: [__meta_kubernetes_endpoint_address_target_kind]
        target_label: kubernetes_cluster
      - action: replace
        source_labels: [__meta_kubernetes_pod_node_name]
        target_label: kubernetes_node_name
      scheme: http
      scrape_interval: {{ prometheus_scrape_interval }}
      scrape_timeout: {{ prometheus_scrape_timeout }}

    - job_name: kubeci
      kubernetes_sd_configs:
      - role: endpoints
        selectors:
        - label: {{ prometheus_service_label }}={{ prometheus_match }}
          role: endpoints
      relabel_configs:
      - action: replace
        replacement: {{ prometheus_local_cluster }}
        source_labels: [__meta_kubernetes_endpoint_address_target_kind]
        target_label: kubernetes_cluster
      - action: replace
        regex: (.+)
        source_labels: [__meta_kubernetes_service_annotation_prometheus_io_path]
        target_label: __metrics_path__
      - action: keep
        regex: '(exporter-[0-9]*|tcp-9113)'
        source_labels: [__meta_kubernetes_endpoint_port_name]
      - action: replace
        source_labels: [__meta_kubernetes_namespace]
        target_label: kubernetes_namespace
      - action: replace
        source_labels: [__meta_kubernetes_pod_node_name]
        target_label: kubernetes_node_name
      - action: replace
        source_labels: [__meta_kubernetes_pod_name]
        target_label: kubernetes_pod_name
      - action: replace
        source_labels: [__meta_kubernetes_pod_label_name]
        target_label: kubernetes_service_name
      scheme: http
      scrape_interval: {{ prometheus_scrape_interval }}
      scrape_timeout: {{ prometheus_scrape_timeout }}

    - job_name: s3buckets
      kubernetes_sd_configs:
      - role: endpoints
        selectors:
        - label: {{ prometheus_s3_label }}={{ prometheus_match }}
          role: endpoints
      relabel_configs:
      - action: replace
        replacement: {{ prometheus_local_cluster }}
        source_labels: [__meta_kubernetes_endpoint_address_target_kind]
        target_label: kubernetes_cluster
      - action: replace
        regex: (.+)
        source_labels: [__meta_kubernetes_service_annotation_prometheus_io_path]
        target_label: __metrics_path__
      - action: keep
        regex: '(exporter-[0-9]*|tcp-9113)'
        source_labels: [__meta_kubernetes_endpoint_port_name]
      - action: replace
        source_labels: [__meta_kubernetes_namespace]
        target_label: kubernetes_namespace
      - action: replace
        source_labels: [__meta_kubernetes_pod_node_name]
        target_label: kubernetes_node_name
      - action: replace
        source_labels: [__meta_kubernetes_pod_name]
        target_label: kubernetes_pod_name
      - action: replace
        source_labels: [__meta_kubernetes_pod_label_name]
        target_label: kubernetes_service_name
      scheme: http
      scrape_interval: {{ prometheus_scrape_s3_interval }}
      scrape_timeout: {{ prometheus_scrape_s3_timeout }}
{% if do_alertmanager %}

    alerting:
      alert_relabel_configs:
      - action: replace
        regex: (.+)
        replacement: {{ prometheus_name }}
        source_labels: [scrape_by]
        target_label: scrape_by
      alertmanagers:
      - scheme: http
        static_configs:
        - targets:
          - {{ alertmanager_name }}.{{ namespace }}.svc.{{ cluster_domain }}:9093
{% endif %}
